//
// Created by Grigoriy Khlytin on 01.12.2021.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll easy_calc(vector<ll> &s) {
    ll total_max = INT32_MIN;

    for (ll i = 0; i < s.size(); i++) {

        //нечетные
        ll k = 0;
        while (0 <= i - k && i + k < s.size() && s[i - k] == s[i + k]) k++;
        if (k != 0) {
            k--;
            total_max = max(total_max, 2LL * k + 1LL);
        }

        //четные
        ll m = 0;
        while (0 <= i - m && i + m + 1 < s.size() && s[i - m] == s[i + m + 1]) m++;
        if (m != 0) {
            m--;
            total_max = max(total_max, 2LL * m + 2LL);
        }

    }

    return total_max;
}

int main() {

    ll n, m;

    cin >> n >> m;

    vector<ll> a(n);
    vector<ll> b(m);

    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (ll j = 0; j < m; j++) {
        cin >> b[j];
    }

    //перебор

    ll total_max = INT32_MIN;

    for (ll pos = 0; pos < n; pos++) {
        vector<ll> tmp;
        tmp.reserve(min(n, m));

        for (ll i = 0; i < m; i++) {
            if (pos + i >= n) {
                break;
            }
            tmp.push_back(a[pos + i] + b[i]);
        }

        total_max = max(total_max, easy_calc(tmp));
    }

    for (ll pos = 0; pos < m; pos++) {
        vector<ll> tmp;
        tmp.reserve(min(n, m));

        for (ll i = 0; i < n; i++) {
            if (pos + i >= m) {
                break;
            }
            tmp.push_back(b[pos + i] + a[i]);
        }

        total_max = max(total_max, easy_calc(tmp));
    }

    cout << total_max;

    return 0;
}
