//
// Created by Grigoriy Khlytin on 01.12.2021.
//

#include "testlib.h"

using namespace std;

typedef long long ll;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int g = validator.group().empty() ? 4 : validator.group()[0] - '0';

    ll n_limit, m_limit;
    if (g == 1) {
        n_limit = 300;
        m_limit = 300;
    } else if (g == 3) {
        n_limit = 500;
        m_limit = 100'000;
    } else {
        n_limit = 100'000;
        m_limit = 100'000;
    }

    ll n = inf.readLong(1LL, n_limit, "n");

    inf.readSpace();

    ll m = inf.readLong(1LL, m_limit, "m");

    inf.readEoln();

    for (int i = 0; i < n; i++) {
        inf.readLong(1LL, 100LL, "x");

        if (i != n - 1) {
            inf.readSpace();
        } else {
            inf.readEoln();
        }
    }

    vector<ll> xs(m);
    for (int i = 0; i < m; i++) {
        ll x = inf.readLong(1LL, 100LL, "x");
        xs[i] = x;

        if (g == 2)
            ensuref(xs[i] == xs[0], "b_i must be equal to b_0!");

        if (i != m - 1) {
            inf.readSpace();
        } else {
            inf.readEoln();
        }
    }

    inf.readEof();
}
